use druid::{Data, Env, Widget};

use self::fill_container::FillContainer;
use self::hidden_if::HiddenIf;

pub mod container;
pub mod fill_container;
pub mod hidden_if;

pub trait ExtraWidgetExt<T: Data>: Widget<T> + Sized + 'static {
    fn content_must_fill(self) -> FillContainer<T> {
        FillContainer::new(self)
    }

    fn hidden_if(self, hidden_if: impl Fn(&T, &Env) -> bool + 'static) -> HiddenIf<T, Self> {
        HiddenIf::new(self, hidden_if)
    }
}

impl<T: Data, W: Widget<T> + 'static> ExtraWidgetExt<T> for W {}
